import type { CompactOrOp } from '../codec/compact/types';
import { AbstractSecondOrderPredicateOp } from './AbstractSecondOrderPredicateOp';
import { AbstractPredicateOp } from './AbstractPredicateOp';
import { OperationOr } from '../types';
import { OPCODE } from '../constants';
import { Path } from '../../json-pointer';
import { AbstractOp } from './AbstractOp';
import type { IMessagePackEncoder } from '../../json-pack/msgpack';
export declare class OpOr extends AbstractSecondOrderPredicateOp<'or'> {
    readonly ops: AbstractPredicateOp[];
    constructor(path: Path, ops: AbstractPredicateOp[]);
    op(): "or";
    code(): OPCODE;
    test(doc: unknown): boolean;
    toJson(parent?: AbstractOp): OperationOr;
    toCompact(parent: undefined | AbstractOp, verbose: boolean): CompactOrOp;
    encode(encoder: IMessagePackEncoder, parent?: AbstractOp): void;
}
