"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BlockPatch = exports.Block = exports.BlockSeq = exports.BlockId = void 0;
const system_1 = require("../system");
exports.BlockId = system_1.t.str.options({
    title: 'Block ID',
    min: 6,
    max: 40,
});
exports.BlockSeq = system_1.t.num.options({
    title: 'Block Sequence Number',
    gte: 0,
    format: 'i32',
});
exports.Block = system_1.t.Object(system_1.t.prop('id', system_1.t.Ref('BlockId')), system_1.t.prop('seq', system_1.t.Ref('BlockSeq')), system_1.t.prop('created', system_1.t.num), system_1.t.prop('updated', system_1.t.num), system_1.t.prop('blob', system_1.t.bin));
exports.BlockPatch = system_1.t.Object(system_1.t.prop('seq', system_1.t.num), system_1.t.prop('created', system_1.t.num), system_1.t.prop('blob', system_1.t.bin));
