import { MapFanOut, OnNewFanOut } from './fanout';
export class NodeEvents {
    api;
    onChanges;
    onViewChanges;
    constructor(api) {
        this.api = api;
        this.onChanges = new MapFanOut(this.api.api.onChanges, this.getSnapshot);
        this.onViewChanges = new OnNewFanOut(this.onChanges);
    }
    handleDelete() {
        this.onViewChanges.clear();
        this.onChanges.clear();
    }
    subscribe = (callback) => this.onViewChanges.listen(() => callback());
    getSnapshot = () => this.api.view();
}
