export const remove = ({ services }) => (router) => {
    const t = router.t;
    const Request = t.Object(t.prop('id', t.Ref('BlockId')).options({
        title: 'Block ID',
        description: 'The ID of the block to delete.',
    }));
    const Response = t.obj;
    const Func = t
        .Function(Request, Response)
        .options({
        title: 'Read Block',
        intro: 'Retrieves a block by ID.',
        description: 'Fetches a block by ID.',
    })
        .implement(async ({ id }) => {
        await services.blocks.remove(id);
        return {};
    });
    return router.fn('blocks.remove', Func);
};
