export const ping = (deps) => (router) => {
    const t = router.t;
    const req = t.any;
    const res = t.Const('pong');
    const func = t.Function(req, res).implement(async () => {
        return 'pong';
    });
    return router.fn('util.ping', func);
};
export const echo = (deps) => (router) => {
    const t = router.t;
    const req = t.any;
    const res = t.any;
    const func = t.Function(req, res).implement(async (msg) => msg);
    return router.fn('util.echo', func);
};
export const info = ({ services }) => (router) => {
    const t = router.t;
    const Request = t.any;
    const Response = t.Object(t.prop('now', t.num), t.prop('stats', t.Object(t.prop('pubsub', t.Object(t.prop('channels', t.num), t.prop('observers', t.num))), t.prop('presence', t.Object(t.prop('rooms', t.num), t.prop('entries', t.num), t.prop('observers', t.num))), t.prop('blocks', t.Object(t.prop('blocks', t.num), t.prop('patches', t.num))))));
    const Func = t.Function(Request, Response).implement(async () => {
        return {
            now: Date.now(),
            stats: {
                pubsub: services.pubsub.stats(),
                presence: services.presence.stats(),
                blocks: services.blocks.stats(),
            },
        };
    });
    return router.fn('util.info', Func);
};
export const schema = (deps) => (router) => {
    const t = router.t;
    const Request = t.any;
    const Response = t.Object(t.prop('typescript', t.str));
    const Func = t.Function(Request, Response).implement(async () => {
        return {
            typescript: deps.router.toTypeScript(),
        };
    });
    return router.fn('util.schema', Func);
};
export const util = (deps) => (r) => (ping(deps)(echo(deps)(info(deps)(schema(deps)(r)))));
