import type * as types from './types';
export declare class MemoryStore implements types.Store {
    protected readonly blocks: Map<string, types.StoreBlock>;
    protected readonly patches: Map<string, types.StorePatch[]>;
    get(id: string): Promise<types.StoreGetResult | undefined>;
    create(id: string, patches: types.StorePatch[]): Promise<types.StoreApplyResult>;
    edit(id: string, patches: types.StorePatch[]): Promise<types.StoreApplyResult>;
    history(id: string, min: number, max: number): Promise<types.StorePatch[]>;
    remove(id: string): Promise<void>;
    private removeSync;
    stats(): {
        blocks: number;
        patches: number;
    };
    removeOlderThan(ts: number): Promise<void>;
}
