import type { IJsonCrdtPatchEditOperation, IJsonCrdtPatchOperation } from './types';
import { type ITimestampStruct, type ITimespanStruct } from './clock';
export declare class NewConOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    readonly val: unknown | undefined | ITimestampStruct;
    constructor(id: ITimestampStruct, val: unknown | undefined | ITimestampStruct);
    span(): number;
    name(): "new_con";
    toString(tab?: string): string;
}
export declare class NewValOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_val";
    toString(): string;
}
export declare class NewObjOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_obj";
    toString(): string;
}
export declare class NewVecOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_vec";
    toString(): string;
}
export declare class NewStrOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_str";
    toString(): string;
}
export declare class NewBinOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_bin";
    toString(tab?: string): string;
}
export declare class NewArrOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    constructor(id: ITimestampStruct);
    span(): number;
    name(): "new_arr";
    toString(): string;
}
export declare class InsValOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly val: ITimestampStruct;
    constructor(id: ITimestampStruct, obj: ITimestampStruct, val: ITimestampStruct);
    span(): number;
    name(): "ins_val";
    toString(tab?: string): string;
}
export declare class InsObjOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly data: [key: string, value: ITimestampStruct][];
    constructor(id: ITimestampStruct, obj: ITimestampStruct, data: [key: string, value: ITimestampStruct][]);
    span(): number;
    name(): "ins_obj";
    toString(tab?: string): string;
}
export declare class InsVecOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly data: [key: number, value: ITimestampStruct][];
    constructor(id: ITimestampStruct, obj: ITimestampStruct, data: [key: number, value: ITimestampStruct][]);
    span(): number;
    name(): "ins_vec";
    toString(tab?: string): string;
}
export declare class InsStrOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly ref: ITimestampStruct;
    readonly data: string;
    constructor(id: ITimestampStruct, obj: ITimestampStruct, ref: ITimestampStruct, data: string);
    span(): number;
    name(): "ins_str";
    toString(): string;
}
export declare class InsBinOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly ref: ITimestampStruct;
    readonly data: Uint8Array;
    constructor(id: ITimestampStruct, obj: ITimestampStruct, ref: ITimestampStruct, data: Uint8Array);
    span(): number;
    name(): "ins_bin";
    toString(tab?: string): string;
}
export declare class InsArrOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly ref: ITimestampStruct;
    readonly data: ITimestampStruct[];
    constructor(id: ITimestampStruct, obj: ITimestampStruct, ref: ITimestampStruct, data: ITimestampStruct[]);
    span(): number;
    name(): "ins_arr";
    toString(): string;
}
export declare class DelOp implements IJsonCrdtPatchEditOperation {
    readonly id: ITimestampStruct;
    readonly obj: ITimestampStruct;
    readonly what: ITimespanStruct[];
    constructor(id: ITimestampStruct, obj: ITimestampStruct, what: ITimespanStruct[]);
    span(): number;
    name(): "del";
    toString(): string;
}
export declare class NopOp implements IJsonCrdtPatchOperation {
    readonly id: ITimestampStruct;
    readonly len: number;
    constructor(id: ITimestampStruct, len: number);
    span(): number;
    name(): "nop";
    toString(): string;
}
