"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createJsonWsRpcClient = void 0;
const json_1 = require("../../json-pack/codecs/json");
const Writer_1 = require("../../util/buffers/Writer");
const common_1 = require("../common");
const RpcCodec_1 = require("../common/codec/RpcCodec");
const compact_1 = require("../common/codec/compact");
const createJsonWsRpcClient = (url, token) => {
    const writer = new Writer_1.Writer(1024 * 4);
    const msg = new compact_1.CompactRpcMessageCodec();
    const req = new json_1.JsonJsonValueCodec(writer);
    const codec = new RpcCodec_1.RpcCodec(msg, req, req);
    const client = new common_1.RpcPersistentClient({
        codec,
        channel: {
            newChannel: () => new common_1.WebSocketChannel({
                newSocket: () => new WebSocket(url, [codec.specifier(), token]),
            }),
        },
    });
    client.start();
    return client;
};
exports.createJsonWsRpcClient = createJsonWsRpcClient;
