"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const tslib_1 = require("tslib");
const create = ({ services }) => (router) => {
    const t = router.t;
    const Request = t.Object(t.prop('id', t.Ref('BlockId')).options({
        title: 'New block ID',
        description: 'The ID of the new block.',
    }), t.prop('patches', t.Array(t.Ref('BlockPatch'))).options({
        title: 'Patches',
        description: 'The patches to apply to the document.',
    }));
    const Response = t.obj;
    const Func = t
        .Function(Request, Response)
        .options({
        title: 'Create Block',
        intro: 'Creates a new block or applies patches to it.',
        description: 'Creates a new block or applies patches to it.',
    })
        .implement(({ id, patches }) => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        const { block } = yield services.blocks.create(id, patches);
        return {};
    }));
    return router.fn('blocks.create', Func);
};
exports.create = create;
