"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.listen = void 0;
const rxjs_1 = require("rxjs");
const listen = ({ services }) => (router) => {
    const t = router.t;
    const req = t.Object(t.prop('channel', t.str).options({
        title: 'Channel name',
        description: 'The name of the channel to subscribe to.',
    }));
    const res = t.Object(t.prop('message', t.any).options({
        title: 'Subscription message',
        description: 'A message received from the channel. Emitted every time a message is published to the channel.',
    }));
    const func = t.Function$(req, res).implement((req) => {
        const response = req.pipe((0, rxjs_1.switchMap)((req) => services.pubsub.listen$(req.channel)), (0, rxjs_1.map)((message) => ({ message })));
        return response;
    });
    return router.fn$('pubsub.listen', func);
};
exports.listen = listen;
