"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.util = exports.schema = exports.info = exports.echo = exports.ping = void 0;
const tslib_1 = require("tslib");
const ping = (deps) => (router) => {
    const t = router.t;
    const req = t.any;
    const res = t.Const('pong');
    const func = t.Function(req, res).implement(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return 'pong';
    }));
    return router.fn('util.ping', func);
};
exports.ping = ping;
const echo = (deps) => (router) => {
    const t = router.t;
    const req = t.any;
    const res = t.any;
    const func = t.Function(req, res).implement((msg) => tslib_1.__awaiter(void 0, void 0, void 0, function* () { return msg; }));
    return router.fn('util.echo', func);
};
exports.echo = echo;
const info = ({ services }) => (router) => {
    const t = router.t;
    const Request = t.any;
    const Response = t.Object(t.prop('now', t.num), t.prop('stats', t.Object(t.prop('pubsub', t.Object(t.prop('channels', t.num), t.prop('observers', t.num))), t.prop('presence', t.Object(t.prop('rooms', t.num), t.prop('entries', t.num), t.prop('observers', t.num))), t.prop('blocks', t.Object(t.prop('blocks', t.num), t.prop('patches', t.num))))));
    const Func = t.Function(Request, Response).implement(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return {
            now: Date.now(),
            stats: {
                pubsub: services.pubsub.stats(),
                presence: services.presence.stats(),
                blocks: services.blocks.stats(),
            },
        };
    }));
    return router.fn('util.info', Func);
};
exports.info = info;
const schema = (deps) => (router) => {
    const t = router.t;
    const Request = t.any;
    const Response = t.Object(t.prop('typescript', t.str));
    const Func = t.Function(Request, Response).implement(() => tslib_1.__awaiter(void 0, void 0, void 0, function* () {
        return {
            typescript: deps.router.toTypeScript(),
        };
    }));
    return router.fn('util.schema', Func);
};
exports.schema = schema;
const util = (deps) => (r) => ((0, exports.ping)(deps)((0, exports.echo)(deps)((0, exports.info)(deps)((0, exports.schema)(deps)(r)))));
exports.util = util;
